using System;
using System.Runtime.InteropServices;
using SDL2;
using SlatedGameToolkit.Framework.Exceptions;

namespace SlatedGameToolkit.Framework.Graphics
{
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLClearColour(float r, float g, float b);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLClear(GLEnums flags);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLViewport(int x, int y, int width, int height);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate UIntPtr GLCreateShader(GLEnums type);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate UIntPtr GLShaderSource(UIntPtr shaderHandle, uint count, string program, int[] length);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLCompileShader(UIntPtr shaderHandle);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLGetShaderLogInfo(UIntPtr shader, uint maxLength, out uint writtenLength, out string output);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate UIntPtr GLCreateProgram();
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate UIntPtr GLDeleteProgram(UIntPtr program);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLAttachShader(UIntPtr program, UIntPtr shader);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLDetachShader(UIntPtr program, UIntPtr shader);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLDeleteShader(UIntPtr shader);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLBindAttribLocation(UIntPtr program, uint index, string name);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLGetProgramInfoLog(UIntPtr program, uint maxLength, out uint writtenLength, out string output);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLLinkProgram(UIntPtr program);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLProgramParameter(UIntPtr program, GLEnums parameterName, int value);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLUseProgram(UIntPtr program);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLGenProgramPipelines(uint size, UIntPtr[] pipelines);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLDeleteProgramPipelines(uint size, UIntPtr[] pipelines);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLBindProgramPipeline(UIntPtr pipeline);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLUseProgramStages(UIntPtr pipeline, GLEnums bitField, UIntPtr program);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate uint GLGetError();
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate int GLGetAttribLocation(UIntPtr program, string attribName);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLBindBuffer(GLEnums target, UIntPtr buffer);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLGenBuffers(uint size, UIntPtr[] buffers);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public unsafe delegate void GLBufferData(GLEnums target, uint size, Array data, GLEnums usage);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLDeleteBuffers(uint size, UIntPtr[] buffers);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLVertexAttribPointer(uint index, int size, GLEnums type, bool normalized, uint stride, uint offset);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLGenVertexArrays(uint amount, UIntPtr[] arrays);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLDeleteVertexArrays(uint amount, UIntPtr[] arrays);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLBindVertexArray(UIntPtr array);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]   
    public delegate void GLEnableVertexAttribArray(uint attribIndex);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLDisableVertexAttribArray(uint attribIndex);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLDrawArrays(GLEnums mode, int first, uint count);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLDrawElements(GLEnums mode, uint count, int offset);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLMultiDrawArrays(GLEnums mode, int[] first, uint[] count, uint primout);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLMultiDrawElements(GLEnums mode, uint[] count, GLEnums type, IntPtr indices, int length);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLGenTextures(uint n, UIntPtr[] textureHandles);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLBindTexture(GLEnums target, UIntPtr texture);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLDeleteTextures(uint n, UIntPtr[] textureHandles);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLTexParameteri(GLEnums target, GLEnums pname, int value);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLTexParameterf(GLEnums target, GLEnums pname, float value);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLTexParameteriv(GLEnums target, GLEnums pname, int[] values);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLTexParameterfv(GLEnums target, GLEnums pname, float[] values);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLTexImage2D(GLEnums target, int level, int publicFormat, uint width, uint height, int border, GLEnums format, GLEnums type, byte[] data);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void GLGenerateMipMap(GLEnums target);

    public static class GLFunctionUtils {
        /// <summary>
        /// Attempts to retrieve and instantiate an OpenGL function as a C# delegate.
        /// Make sure the delegates signature is correct as failing to do so will potentially 
        /// lead to a CLR error on usage.
        /// 
        /// Uses SDL2 as the function address retriever.
        /// </summary>
        /// <param name="functionName">The process name, case sensitive, exactly as OpenGL defines it.</param>
        /// <typeparam name="T">The delegate type to cast to.</typeparam>
        /// <returns>The delegate associated with the retrieved path.</returns>
        public static T RetrieveGLDelegate<T>(string functionName) where T : Delegate {
            GameEngine.Logger.Debug(String.Format("Retrieving function with name: {0}", functionName));
            IntPtr functionAddress = SDL.SDL_GL_GetProcAddress(functionName);
            if (functionAddress == null) throw new FrameworkSDLException();
            return Marshal.GetDelegateForFunctionPointer<T>(functionAddress);
        }
    }
}