using System;
using System.Runtime.InteropServices;
using SDL2;
using SlatedGameToolkit.Framework.Exceptions;
using SlatedGameToolkit.Framework.Graphics.Textures;
using SlatedGameToolkit.Framework.Loader;

namespace SlatedGameToolkit.Framework.Loader
{
    public class TextureLoader : ILoadable
    {
        public string FileName {get; private set; }
        public TextureLoader(string path) {
            this.FileName = path;
        }

        public IAssetUseable Load(PathModifier pathModifier = null)
        {
            IntPtr ptr = SDL_image.IMG_Load(pathModifier(FileName));
            if (ptr == null) throw new FrameworkSDLException();
            SDL.SDL_Surface surface = Marshal.PtrToStructure<SDL.SDL_Surface>(ptr);
            TextureData textureData = new TextureData();
            byte[] data = new byte[surface.pitch * surface.h];
            Marshal.Copy(surface.pixels, data, 0, data.Length);
            IAssetUseable useable = new Texture(textureData);
            return useable;
        }
    }
}